Attribute VB_Name = "modLibrary"
Option Explicit

Public Outgoing As String 'I didn't change this

'Handler entry point
Sub HandlePacket(BotIndex As Byte, DecryptedPacket As String)
If DecryptedPacket = "" Then Exit Sub 'avoid Invalid Procedure Call or Argument that will cause a crash

If Left(DecryptedPacket, 1) = Chr(0) Then
 With Bots(BotIndex)
 Dim I As Integer, b As Byte, S As String
 Select Case Asc(Mid(DecryptedPacket, 2, 1)) 'O2 types
 Case 1 'SessionRequest
 Case 2 'KeyNotify
  'Server sent a key
  InitEncryption BotIndex, GetLong(Mid(DecryptedPacket, 3, 4))
'''  .SSEncrKey = GetLong(Mid(DecryptedPacket, 3, 4))
'''  '.SSEncrKey = GetLong(Mid(DecryptedPacket, 3, 4)) Xor (GetLong(Chr(196) & Chr(172) & Chr(231) & Chr(139)))
  .AutoConnect = 0
  SendLogin BotIndex, .Name, .Password, GetMacID(BotIndex, .MacID), TimeZoneBias + .TimeZoneBiasAdjust, 4537, 0
 Case 3 'ACKRequired
  'Server sent a message requiring an ACK in response
  UDPSend BotIndex, Chr(0) + Chr(4) + Mid(DecryptedPacket, 3, 4), False
  I = GetInteger(Mid(DecryptedPacket, 3, 2))
  If I = -1 Then
   ClearACKs BotIndex
  ElseIf ACKs(BotIndex, I) Then
   Exit Sub
  Else
   ACKs(BotIndex, I) = 1
  End If
'  CheckBacklog BotIndex, DecryptedPacket, I
  HandleGamePacket BotIndex, Mid(DecryptedPacket, 7) 'replaced this with everything "backlog"
 Case 4 'ACKMessage
'  on error GoTo WeirdError
'  For b = 1 To MAX_SECURES
'   If Secures(b).ResendCount > 0 And Mid(Secures(b).Message, 3, 2) = Mid(DecryptedPacket, 3, 2) Then
'    Secures(b).ResendCount = 0
'    UpdateLag Secures(b).BotFrom, GetTickCount - Secures(b).InitialTicks
'    Exit Sub
'   End If
'  Next
'WeirdError:
 Case 5 'SyncClient
  'Send a ping response.  Newer servers might block access if no response is sent.
  UDPSend BotIndex, Chr(0) + Chr(6) + Mid(DecryptedPacket, 3, 4) + GetStringL(SSPingValue), False
 Case 6 'SyncServer
  'Server accepted the synchronization packet
'  .SyncDiff = GetLong(Mid(DecryptedPacket, 7, 4)) - .SyncLocal - .AvgPing
  .SyncDiff = GetLong(Mid(DecryptedPacket, 7, 4)) - .SyncLocal
  .GotSync = 1
 Case 7 'Disconnect
  If .AutoConnect Then 'got disconnected while trying to connect
   AddTerminal BotIndex, "Disconnected. Connection refused.", 12
   UnloadBot BotIndex, 0
  Else 'got disconnected while being connected. .autoconnect sets to 0 before sending login or when unloaded bot
   AddTerminal BotIndex, "Disconnected. Reconnecting...", 12
   ResetSession BotIndex
   LogoffAllUsers BotIndex 'needed. it's in LeaveServer and LeaveArena. LeaveServer is called on in UnloadBot, LeaveArena when we move bot with -go. Since we are not leaving server/arena, but are reconnecting from being kicked, we must delete all users here
   ConnectBot BotIndex
  End If
 Case 8 'RegistrationForm
 Case 9 'ModemInfo
 Case 10 'DataStream
 Case 14 'PacketCluster
  S = Mid(DecryptedPacket, 3)
  Do
   b = Asc(Left(S, 1))
   HandlePacket BotIndex, Mid(S, 2, b)
   S = Mid(S, b + 2)
  Loop Until S = ""
 Case Else
  AddTerminal BotIndex, "Unknown O2 type: " + CStr(Asc(Mid(DecryptedPacket, 2, 1))), 12
 End Select
 End With
Else
 HandleGamePacket BotIndex, DecryptedPacket
End If
End Sub

'In-game event packets
Sub HandleGamePacket(BotIndex As Byte, ByVal DecryptedPacket As String)
If DecryptedPacket = "" Then Exit Sub 'avoid Invalid Procedure Call or Argument that will cause a crash

On Error GoTo FlyPaper
Dim L As Long, L2 As Long, L3 As Long, S As String, S2 As String, S3 As String, S4 As String
Dim f As Boolean, f2 As Boolean, f3 As Boolean, f4 As Boolean
Dim I As Integer, I2 As Integer, I3 As Integer, I4 As Integer, I5 As Integer, I6 As Integer, I7 As Integer

With Bots(BotIndex)
'Server wants to tell me about the game events
Select Case Asc(Left(DecryptedPacket, 1)) 'Packet types
Case 0 'SendingFile
 Select Case Asc(Mid(DecryptedPacket, 2, 1)) 'FTP types
 Case 8 'Body
  If FTPList(BotIndex).FTP_Name = "" Then
   FTPList(BotIndex).FTP_Type = Asc(Mid(DecryptedPacket, 3, 1))
   S = TrimZero(Mid(DecryptedPacket, 4, 16))
   If S = "" Then
    FTPList(BotIndex).FTP_Name = "Arena settings"
   Else
    FTPList(BotIndex).FTP_Name = S
    AddTerminal BotIndex, "Receiving file(0): " + FTPList(BotIndex).FTP_Name, 9
   End If
   FTPList(BotIndex).FTP_Data = Mid(DecryptedPacket, 20)
  Else
   FTPList(BotIndex).FTP_Data = FTPList(BotIndex).FTP_Data + Mid(DecryptedPacket, 3)
  End If
 Case 9 'Done
  If FTPList(BotIndex).FTP_Type <> SimpleSettings Then
   FTPList(BotIndex).FTP_Data = FTPList(BotIndex).FTP_Data + Mid(DecryptedPacket, 3)
   PutBytes FTPList(BotIndex).FTP_Name, FTPList(BotIndex).FTP_Data
   AddTerminal BotIndex, "File received(0): " + FTPList(BotIndex).FTP_Name, 9
  End If
  FTPList(BotIndex).FTP_Name = ""
 Case 10 'BodyExtended
  If FTPList(BotIndex).FTP_Name = "" Then
   FTPList(BotIndex).FTP_Name = TrimZero(Mid(DecryptedPacket, 8, 16))
   FTPList(BotIndex).FTP_Data = Mid(DecryptedPacket, 24)
   FTPList(BotIndex).FTP_FileLen = GetLong(Mid(DecryptedPacket, 3, 4))
   FTPList(BotIndex).FTP_Recved = Len(FTPList(BotIndex).FTP_Data)
   AddTerminal BotIndex, "Receiving file(1): " + FTPList(BotIndex).FTP_Name + " ( " + CStr(FTPList(BotIndex).FTP_FileLen) + " bytes )", 9
  Else
   S = Mid(DecryptedPacket, 7)
   FTPList(BotIndex).FTP_Recved = FTPList(BotIndex).FTP_Recved + Len(S)
   FTPList(BotIndex).FTP_Data = FTPList(BotIndex).FTP_Data + S
   If FTPList(BotIndex).FTP_Recved + 17 >= FTPList(BotIndex).FTP_FileLen Then
    PutBytes FTPList(BotIndex).FTP_Name, FTPList(BotIndex).FTP_Data
    If .DownloadingSettings Then GotSettings BotIndex, FTPList(BotIndex).FTP_Name
    AddTerminal BotIndex, "File received(1): " + FTPList(BotIndex).FTP_Name, 9
    FTPList(BotIndex).FTP_Name = ""
   End If
  End If
 End Select
Case 25 'AllowSend
 UDPSend BotIndex, Chr(0) + Chr(10) + GetStringL(Len(Outgoing)) + Chr(16) + Mid(DecryptedPacket, 264, 16) + Left(Outgoing, 463), True
 For I = 464 To Len(Outgoing) Step 482
  UDPSend BotIndex, Chr(0) + Chr(10) + GetStringL(Len(Outgoing)) + Mid(Outgoing, I, 482), True
 Next
 Outgoing = ""
Case 41 'MapFilename
 AddTerminal BotIndex, "Map playing: " + TrimZero(Mid(DecryptedPacket, 2, 16)), 0
' MapDefaultName = TrimZero(Mid(DecryptedPacket, 2, 16))
' AddTerminal 0, "Map filename: " + MapDefaultName, 0
' LoadMap MapDefaultDir & "\" & MapDefaultName, rError 'loading map for the bot to fly in
' If rError > "" Then AddTerminal 0, rError, 0
Case 1 'YouAreHere
 .UserID = Asc(Mid(DecryptedPacket, 2, 1)) 'index of bot among players
Case 2 'SpawnConnected
 .Spawning = 0
 AddTerminal BotIndex, "SPAWN CONNECTED", 10
 S = GetSpawnConnected(BotIndex) 'will be looking with which ip/port we connected, local or remote
 If S = "Local" Then PublicMessage BotIndex, "*" + .LocalSysopPassword, 0
 If S = "Remote" Then PublicMessage BotIndex, "*" + .RemoteSysopPassword, 0
 EnableBot BotIndex, .UserID, GetProfile("Bot" & (BotIndex), "Enabled", 1, 1) 'when bot auto-enables, he has sysop powers
 EnableMonkeyBot BotIndex, .UserID, GetProfile("Bot" & (BotIndex), "Monkey", 0, 1)
 PrivateMessage BotIndex, .UserID, "*setfreq " + CStr(.Freq), 0
 SetErrorChannel BotIndex, .UserID, .ErrorChannel
' LastBot = LastBot - (BotIndex - LastBot) * (BotIndex > LastBot) 'in spawnbot, if lastbot=max_bots, it will exit and not spawn, thus not come to this point
 If BotIndex > LastBot Then LastBot = BotIndex 'can't use statement above because lastbot is a byte and i was using negatives
 .SpawnConnected = 1
Case 3 'PlayersEntering
'---------------------------------------------------#------------ userid
'---####################----------------------------------------- name
'-----------------------###################---------------------- squad
'-----------------------------------------------------##--------- freq
'-#-------------------------------------------------------------- ship
'-------------------------------------------------------##------- wins
'---------------------------------------------------------##----- losses
'-------------------------------------------########------------- points
'Debug.Print Mid(DecryptedPacket, I + 2, 1)
'Debug.Print Mid(DecryptedPacket, I + 42, 1)
'Debug.Print Mid(DecryptedPacket, I + 52, 1)
'Debug.Print Mid(DecryptedPacket, I + 59, 5)
'Debug.Print "-----"
 For I = 1 To Len(DecryptedPacket) Step 64
  If Asc(Mid(DecryptedPacket, I, 1)) = 3 Then LoginUser BotIndex, Asc(Mid(DecryptedPacket, I + 51, 1)), TrimZero(Mid(DecryptedPacket, I + 3, 20)), TrimZero(Mid(DecryptedPacket, I + 23, 19)), GetInteger(Mid(DecryptedPacket, I + 53, 2)), Asc(Mid(DecryptedPacket, I + 1, 1)), GetInteger(Mid(DecryptedPacket, I + 55, 2)), GetInteger(Mid(DecryptedPacket, I + 57, 2)), GetLong(Mid(DecryptedPacket, I + 43, 4)) + GetLong(Mid(DecryptedPacket, I + 47, 4))
 Next
Case 4 'PlayerQuit
 I = Asc(Mid(DecryptedPacket, 2, 1))
 If I = .AttachedTo Then .AttachedTo = -1
 If .Users(I).Playing Then
  DelPlaying BotIndex, I
  If (.Type = 1 Or .Type = 7) And .Enabled And .Status = started Then
   UpdateRank .Users(I).Name, False, .Users(I).Wins, .Users(I).Losses
  End If
 End If
 If .Enabled Then
  If .Type = 5 And .Status = started Then
   KillConquerPlayer BotIndex, I
  ElseIf .Type = 6 And I = .BountyRabbitUserIndex Then 'bounty rabbit logged out, pick new rabbit
   LogoffUser BotIndex, I 'user must be deleted from .users() array first so that sub NewRabbit would know new number of players
   NewRabbit BotIndex, 5
   Exit Sub
  End If
 End If
 LogoffUser BotIndex, I
Case 47 'ArenaList
 S = Mid(DecryptedPacket, 2)
 AddTerminal BotIndex, "-=Arena list=-", 0
 Do While S > ""
  I = I + 1
  AddTerminal BotIndex, CStr(I) + " -> '" + TrimZero(S) + "' (" + CStr(Asc(Mid(S, Len(TrimZero(S)) + 2, 1))) + " players)", 0
  S = Mid(S, Len(TrimZero(S)) + 4)
 Loop
'Case 44 'KoTHReset
' UDPSend BotIndex, Chr(30), True 'i don't know what this does
Case 6 'KillMessage
'  Dim xx As Integer
'  For xx = 1 To Len(DecryptedPacket)
'   S2 = Asc(Mid(DecryptedPacket, xx, 1))
'   S = S & S2 & Space(3 - Len(S2)) & " "
'  Next
'  frmTerminal.List1.AddItem S
'  If frmTerminal.List1.ListCount > 32000 Then frmTerminal.List1.RemoveItem 0
'  frmTerminal.List1.ListIndex = frmTerminal.List1.ListCount - 1
 I = Asc(Mid(DecryptedPacket, 5, 1)) 'killed
 I2 = Asc(Mid(DecryptedPacket, 3, 1)) 'killer
 I3 = GetInteger(Mid(DecryptedPacket, 7, 2)) 'how many points kill
 If .Type = 1 Or .Type = 7 Then
  .Users(I).Losses = .Users(I).Losses + 1
  I4 = 1
  If .Type = 7 Then
   If .Users(I2).Losses >= .MaxDeaths Then I4 = 0 'in freeelim you are still in ship after getting killed more than .maxdeaths, so we just not let him have the .wins
  End If
  .Users(I2).Wins = .Users(I2).Wins + I4
 End If
 .Users(I2).Points = .Users(I2).Points + I3 'not used with elim games
 HandleScoreChanges BotIndex, I, I2
 HandleScoreChanges BotIndex, I2, -1
 AddLoss BotIndex, .Users(I).Freq
 AddWin BotIndex, .Users(I2).Freq
 AddTerminal BotIndex, .Users(I).Name + "(" + CStr(I3) + ") killed by: " + .Users(I2).Name, 10
Case 7 'Chat Message
 S = TrimZero(Mid(DecryptedPacket, 6))
 I = Asc(Mid(DecryptedPacket, 4, 1)) 'index of player who sent message
 If I = .UserID Then 'bot PMs to himself
'  If InStr(33, S, "*") > 0 Then AppendBytes "packets.log", Mid(S, 33) 'remarked by Catid
 ElseIf I <> -1 Then
  Select Case Asc(Mid(DecryptedPacket, 2, 1)) 'Chat types
  Case 5 'Private_Message (PMing to the bot) if a player pms to another player, the text is not received
   GoSub acceptvotes 'now can pm votes to the bot (subspace ignores duplicate pub messages, but not duplicate pm messages)
   AddTerminal BotIndex, .Users(I).Name + "> " + S, 10
   HandleCommand BotIndex, I, S
  Case 4 'TeamPrivate_Message
   AddTerminal BotIndex, .Users(I).Name + "> " + S, 14
   HandleCommand BotIndex, I, S
  Case 3 'Team_Message
   AddTerminal BotIndex, .Users(I).Name + "> " + S, 14
   HandleCommand BotIndex, I, S
  Case 2 'Public_Message
   GoSub acceptvotes
   AddTerminal BotIndex, .Users(I).Name + "> " + S, 9
   HandleCommand BotIndex, I, S
   Exit Sub
acceptvotes:
   If IsNumeric(S) And .Enabled Then
    S2 = IIf(15 - .GameCounter = 1, " second", " seconds")
    If .Status = VOTE_GAME Then
     .ElimType = AddVote(S, 1, 8, .ElimType, 0) 'adding up votes
     Select Case .ElimType
     Case Vanilla: S3 = "elim"
     Case Race: S3 = "race"
     Case wbelim: S3 = "warbird elim"
     Case wbrace: S3 = "warbird race"
     Case javelim: S3 = "javelin elim"
     Case javrace: S3 = "javelin race"
     Case teamelim: S3 = "team elim"
     Case GolfElim: S3 = "golf elim"
     End Select
     PublicMessage BotIndex, "*arena It is " + S3 + " game. " + CStr(15 - .GameCounter) + S2 + " left to vote", 0
    ElseIf .Status = VOTE_DEATHS Then
     .MaxDeaths = AddVote(S, 1, 10, .MaxDeaths, 0) 'adding up votes
     If .Type = 1 Then 'elim
      Select Case .ElimType
      Case Vanilla, wbelim, javelim, teamelim: S3 = IIf(.MaxDeaths = 1, " death", " deaths")
      Case Race, wbrace, javrace: S3 = IIf(.MaxDeaths = 1, " kill", " kills")
      Case GolfElim: S3 = IIf(.MaxDeaths = 1, " point", " points")
      End Select
     ElseIf .Type = 7 Then 'freeelim
      S3 = IIf(.MaxDeaths = 1, " death", " deaths")
     End If
     PublicMessage BotIndex, "*arena It is " + CStr(.MaxDeaths) + S3 + " game. " + CStr(15 - .GameCounter) + S2 + " left to vote", 0
    End If
   End If
Return
  End Select
 End If
 Select Case Asc(Mid(DecryptedPacket, 2, 1)) 'Chat types
 Case 0 'Arena_Message Chat type
  If .Enabled Then
   If .Type = 6 Then
    Select Case S
    Case "NOTICE: 5 minutes remaining.": PublicMessage BotIndex, "*arena " + .Users(.BountyRabbitUserIndex).Name + "(bounty rabbit) last seen at " + GetPlayerCoords(BotIndex, .BountyRabbitUserIndex) + ". 5 minutes until he wins", 1 * .GameSound
    Case "NOTICE: 1 minute remaining.": PublicMessage BotIndex, "*arena " + .Users(.BountyRabbitUserIndex).Name + "(bounty rabbit) last seen at " + GetPlayerCoords(BotIndex, .BountyRabbitUserIndex) + ". 1 minute until he wins", 1 * .GameSound
    Case "NOTICE: Game over": GameOverRabbit BotIndex
    End Select
   ElseIf .Type = 5 Or .Type = 1 Then
    If .Status = started Then
     If S = "Arena UNLOCKED" Then PublicMessage BotIndex, "*lock", 0
    ElseIf S = "Arena LOCKED" Then
     PublicMessage BotIndex, "*lock", 0
    End If
   End If
  End If
  AddTerminal BotIndex, S, 10
  If AliasFinder Then 'extracts the data from players. when new user comes in, the LoginUser sub sends "*info" if aliasfinder is enabled then this Arena_Message Chat type happens
   If LastAlias = MAX_ALIASES Then
    AddTerminal 0, "Alias database is full.", 12
    Exit Sub
   End If
   I = InStr(S, "IP:")
   I2 = InStr(I + 1, S, "  TimeZoneBias:")
   If I > 0 Then
    If I2 > 0 Then S2 = Mid(S, I + 3, I2 - I - 3)
    I3 = InStr(S, "TypedName:")
    I4 = InStr(I3 + 1, S, "  Demo:")
    If I3 > 0 Then
     If I4 > 0 Then S3 = LCase(Mid(S, I3 + 10, I4 - I3 - 10))
     I5 = InStr(S, "MachineId:")
     If I5 > 0 Then
      S4 = Mid(S, I5 + 10)
      For L = 1 To LastAlias
       If Alias(L).Name = S3 Then
        If Alias(L).MacID = S4 Then
         Exit Sub
        Else
         'log a player if he/she comes in with an existing aliase in database with a different MacID. means that he stole the password, modified MacID, or got a new hard drive
'         AppendBytes "Aliases.log", Date + " " + Time + " " + S3 + ": " + Alias(l).MacID + " changed to " + S4
        End If
       End If
      Next
      LastAlias = LastAlias + 1
      Alias(LastAlias).Name = S3
      Alias(LastAlias).IP = S2
      Alias(LastAlias).MacID = S4
      If StartOfNewAlias = 0 Then StartOfNewAlias = LastAlias 'do this only if it's 0 otherwise it won't save the new ones
     End If
    End If
   End If
  End If
 Case 7 'RemotePrivate_Message chat type
  AddTerminal BotIndex, S, 10
 Case 8 'ServerError_Message Chat type
  If .ErrorChannel > "" Then ChannelM BotIndex, "1;" + S, 0
  AddTerminal BotIndex, S, 12
 Case 9 'Channel_Message chat type
  AddTerminal BotIndex, S, 12
 End Select
Case 8 'LagUpdate
Case 49 'RequestInfo
 SendExtraInfo BotIndex
Case 10 'PasswordAccept
 S = "Password not accepted: "
 Select Case Asc(Mid(DecryptedPacket, 2, 1)) 'Connection failures returned by server at login (of the known varieties)
 Case 0 'None
  AddTerminal BotIndex, "Password packet accepted", 14
  GoTo itsgood
 Case 13 'NO_SCORES
  AddTerminal BotIndex, "Password packet accepted.  The billing server is down", 14
itsgood:
  SendSync BotIndex
  S = GetSpawnConnected(BotIndex) 'will be looking with which ip/port we connected, local or remote
  If S = "Local" Then EnterArena BotIndex, .Ship, .LocalArena, 1600, 1200 '1280
  If S = "Remote" Then EnterArena BotIndex, .Ship, .RemoteArena, 1600, 1200 '1280
 Case 1 'NEW_USER
  AddTerminal BotIndex, "Unknown user   Creating a new account", 14
  SendLogin BotIndex, .Name, .Password, GetMacID(BotIndex, .MacID), TimeZoneBias + .TimeZoneBiasAdjust, 4537, 1
 Case 14 'SERVER_BUSY
  AddTerminal BotIndex, "Busy processing other login requests.  Retrying...", 14
  SendLogin BotIndex, .Name, .Password, GetMacID(BotIndex, .MacID), TimeZoneBias + .TimeZoneBiasAdjust, 4537, 0
 Case 2 'BAD_PW
  AddTerminal BotIndex, S + "Incorrect password", 12
  UnloadBot BotIndex, 0
 Case 3 'IP_BLOCK
  AddTerminal BotIndex, S + App.Title & " is locked out of this zone (IP) or the zone is full", 12
  UnloadBot BotIndex, 0
 Case 4 'ID_BLOCK
  AddTerminal BotIndex, S + App.Title & " is locked out of this zone (Machine ID/IP Range)", 12
  UnloadBot BotIndex, 0
 Case 5 'PERMISSION_ZONE
  AddTerminal BotIndex, App.Title & " is locked out of this zone (Machine ID/Permission zone)", 12
  UnloadBot BotIndex, 0
 Case 16 'NAME_MISSING
  AddTerminal BotIndex, S + "Name is missing", 12
  UnloadBot BotIndex, 0
 Case 15 'ADVANCED_ONLY
  AddTerminal BotIndex, S + "Not enough logged hours (Advanced users only)", 12
  UnloadBot BotIndex, 0
 Case 11 'INVALID_NAME
  AddTerminal BotIndex, S + "Username contains invalid characters", 12
  UnloadBot BotIndex, 0
 Case 12 'OBSCENE_NAME
  AddTerminal BotIndex, S + "Username is in obscene.txt", 12
  UnloadBot BotIndex, 0
 Case Else
  AddTerminal BotIndex, S + "Reason #" + CStr(Asc(Mid(DecryptedPacket, 2, 1))), 12
  UnloadBot BotIndex, 0
 End Select
Case 9 'ScoreUpdate
 I = Asc(Mid(DecryptedPacket, 2, 1))
 .Users(I).Points = GetLong(Mid(DecryptedPacket, 4, 4)) + GetLong(Mid(DecryptedPacket, 8, 4))
 If .Type <> 7 Then 'the .points aren't used by elimref. unlike the normal elim game, mine doesn't get the wins/losses from billing wins/losses; it resets when game starts. *scorereset isn't done
  .Users(I).Wins = GetInteger(Mid(DecryptedPacket, 12, 2))
  .Users(I).Losses = GetInteger(Mid(DecryptedPacket, 14, 2))
  HandleScoreChanges BotIndex, I, -1
 End If
Case 35 'FlagReward
 I = 1
 Do
  I2 = GetInteger(Mid(DecryptedPacket, I + 1, 2)) 'team frequency
  L = GetInteger(Mid(DecryptedPacket, I + 3, 2)) 'points
  For I = 0 To .LastUser
   If .Users(I).Name > "" And .Users(I).Freq = I2 Then .Users(I).Points = .Users(I).Points + L
  Next
  I = I + 4
 Loop While Len(DecryptedPacket) - I > 0
Case 24 'SecurityChecksum
' SendSecurityCheck BotIndex
Case 11 'SoccerGoal
 .BallPlayer = 255
 I2 = GetInteger(Mid(DecryptedPacket, 2, 2)) 'team frequency
 L = GetLong(Mid(DecryptedPacket, 4, 4)) 'points
 For I = 0 To .LastUser
  If .Users(I).Name > "" And .Users(I).Freq = I2 Then .Users(I).Points = .Users(I).Points + L
 Next
Case 19 'FlagClaim
Case 20 'FlagVictory
 I5 = GetInteger(Mid(DecryptedPacket, 2, 2))
 L3 = GetLong(Mid(DecryptedPacket, 4, 4))
 For I = 0 To .LastUser
  If .Users(I).Name > "" And .Users(I).Freq = I5 Then .Users(I).Points = .Users(I).Points + L3
 Next
 If .Type = 3 And .Enabled Then
  For I = 0 To .LastUser
   If .Users(I).Playing Then DelPlaying BotIndex, I
   Select Case .Users(I).Ship
   Case 6: PrivateMessage BotIndex, I, "*setship 5", 0
   Case 7: PrivateMessage BotIndex, I, "*setship 1", 0
   End Select
   If .Users(I).Name > "" And .Users(I).Ship < 8 Then
    Select Case .Users(I).Freq
    Case 0: If .Users(I).Points > L Then I3 = I: L = .Users(I).Points
    Case 1: If .Users(I).Points > L2 Then I4 = I: L2 = .Users(I).Points
    End Select
    I2 = I2 + 1
   End If
  Next
  Select Case I2
  Case Is >= 72
   PublicMessage BotIndex, "*arena " + .Users(I3).Name + "(Imperials) and " + .Users(I4).Name + "(Rebels) are high scorers", 0
   PublicMessage BotIndex, "*arena Please announce two capital ships for your team  -" + .Name, 2 * .GameSound
  Case Is >= 36
   PublicMessage BotIndex, "*arena " + .Users(I3).Name + "(Imperials) and " + .Users(I4).Name + "(Rebels) are high scorers", 0
   PublicMessage BotIndex, "*arena Please announce your team's legal capital ship  -" + .Name, 2 * .GameSound
  Case Else
   PublicMessage BotIndex, "*arena " + .Users(I3).Name + "(Imperials) and " + .Users(I4).Name + "(Rebels) are high scorers", 0
   PublicMessage BotIndex, "*arena No capital ships this game. Have " + CStr(I2) + ":36 players required  -" + .Name, 1 * .GameSound
  End Select
 End If
 AddFlagVictory BotIndex, I5
Case 5 'WeaponsFire
 I = Asc(Mid(DecryptedPacket, 9, 1))
 If I <= MAX_USERS Then
'  Dim xx As Integer
'  For xx = 1 To Len(DecryptedPacket)
'   S2 = Asc(Mid(DecryptedPacket, xx, 1))
'   S = S & S2 & Space(4 - Len(S2))
'  Next
'  frmTerminal.List1.AddItem S
'  If frmTerminal.List1.ListCount > 32000 Then frmTerminal.List1.RemoveItem 0
'  frmTerminal.List1.ListIndex = frmTerminal.List1.ListCount - 1
'i'm trying to make bot die
'1 = 5
'2-3 = Killer's PlayerID
'4-5 = Your bounty
'  I2 = Asc(Mid(DecryptedPacket, 12, 1)) 'who's fired at
'  If I2 = .UserID Then 'bot gets hit (.UserID is index of bot among players. n(0) is player who got shot)
   'UDPSend BotIndex, Chr(6) + Chr(0) + Mid(DecryptedPacket, 9, 1) + Chr(0) + Mid(DecryptedPacket, 12, 1) + Chr(0) + Chr(0) + Chr(0) + Chr(0) + Chr(0), false
   'S = Chr(6) + GetStringL(GetServerTime(BotIndex)) + Mid(DecryptedPacket, 9, 1) + Chr(0) + Mid(DecryptedPacket, 12, 1) + Chr(0) + Chr(0) + Chr(0) + Chr(0) + Chr(0)
   'For I3 = 1 To Len(S)
   ' I4 = I4 Xor Asc(Mid(S, I3, 1))
   'Next
   'UDPSend BotIndex, Left(S, 1) + Chr(I4) + Mid(S, 3), False
  ' If .NumHits = 0 Then .TimeHitsStarted = GetTickCount
  ' .NumHits = .NumHits + 1 'will need to have certain number of hits in certain time length
  ' If .NumHits = 10 Then
  '  .NumHits = 0
  '  If GetTickCount - .TimeHitsStarted <= 400 Then
     'PublicMessage BotIndex, "*arena Bot Killed " + CStr(GetTickCount), 0
  
'  frmTerminal.List1.AddItem GetInteger(Mid(DecryptedPacket, 16, 2)) & " " & GetInteger(Mid(DecryptedPacket, 5, 2))
'  If frmTerminal.List1.ListCount > 32000 Then frmTerminal.List1.RemoveItem 0
'  frmTerminal.List1.ListIndex = frmTerminal.List1.ListCount - 1
  
  '  End If
  ' End If
'  End If
  .Users(I).X = GetInteger(Mid(DecryptedPacket, 5, 2))
  .Users(I).Y = GetInteger(Mid(DecryptedPacket, 16, 2))
  .Users(I).D = Asc(Mid(DecryptedPacket, 2, 1))

'  If .X = .Users(I).X And .Y = .Users(I).Y Then UDPSend BotIndex, Chr(5) & GetStringI(I2) & Chr(0) & Chr(0), False
  If .X = .Users(I).X And .Y = .Users(I).Y Then UDPSend BotIndex, Chr(5) & GetStringI(.UserID) & Chr(0) & Chr(0), False 'close enough
'  If Not (.Users(I).X = 0 Or .Users(I).Y = 0) And Asc(Mid(DecryptedPacket, 10, 1)) <> 16 And (Abs(.Users(I).X - n(0)) > (MAX_X \ 24) Or Abs(.Users(I).Y - n(1)) > (MAX_Y \ 24)) Then
'   AddTerminal BotIndex, "Warning: " + .Users(I).Name + " moved fast without warp signature. (a:" + CStr(Asc(Mid(DecryptedPacket, 10, 1))) + ",nx:" + CStr(Abs(n(0))) + ",ny:" + CStr(Abs(n(1))) + ")" + ",ox:" + CStr(Abs(.Users(I).X)) + ",oy:" + CStr(Abs(.Users(I).Y)) + ")", 12
'  End If
''  .Users(I).Fire = GetInteger(Right(DecryptedPacket, 2)) 'so i could make a player follow a bot and fire his own weapons
'  .AttachedWeapon = GetInteger(Right(DecryptedPacket, 2))
'  If .AttachedWeapon = &H20 Then .AttachedWeapon = 0 (Alt+Tab
  If Not .AntiBot Then Exit Sub
  If Asc(Mid(DecryptedPacket, 14, 1)) = 8 Then GoTo checkantibot
 End If
Case 40 'PositionData
 I = Asc(Mid(DecryptedPacket, 9, 1))
 If I <= MAX_USERS Then
' Dim xx As Integer
' For xx = 1 To Len(DecryptedPacket)
'  S2 = Asc(Mid(DecryptedPacket, xx, 1))
'  S = S & S2 & Space(3 - Len(S2)) & " "
' Next
' frmTerminal.List1.AddItem S
' If frmTerminal.List1.ListCount > 32000 Then frmTerminal.List1.RemoveItem 0
' frmTerminal.List1.ListIndex = frmTerminal.List1.ListCount - 1
  .Users(I).X = GetInteger(Mid(DecryptedPacket, 5, 2))
  .Users(I).Y = GetInteger(Mid(DecryptedPacket, 13, 2))
  .Users(I).D = Asc(Mid(DecryptedPacket, 2, 1))
'  If Not (.Users(I).X = 0 Or .Users(I).Y = 0) And Asc(Mid(DecryptedPacket, 10, 1)) <> 16 And (Abs(.Users(I).X - n(0)) > (MAX_X \ 24) Or Abs(.Users(I).Y - n(1)) > (MAX_Y \ 24)) Then
'   AddTerminal BotIndex, "Warning: " + .Users(I).Name + " moved fast without warp signature. (a:" + CStr(Asc(Mid(DecryptedPacket, 10, 1))) + ",nx:" + CStr(Abs(n(0))) + ",ny:" + CStr(Abs(n(1))) + ")" + ",ox:" + CStr(Abs(.Users(I).X)) + ",oy:" + CStr(Abs(.Users(I).Y)) + ")", 12
'  End If
'     frmTerminal.List2.AddItem .X & " " & .Y
'     If frmTerminal.List2.ListCount > 32000 Then frmTerminal.List2.RemoveItem 0
'     frmTerminal.List2.ListIndex = frmTerminal.List2.ListCount - 1
  If Not .AntiBot Then Exit Sub
  If Asc(Mid(DecryptedPacket, 10, 1)) = 8 Then
checkantibot:
   I4 = .Users(I).X - .AntiPixels / 2
   I5 = .Users(I).Y - .AntiPixels / 2
   I6 = .Users(I).X + .AntiPixels / 2
   I7 = .Users(I).Y + .AntiPixels / 2
   f = (I4 <= .AntiBoxX2 And I4 >= .AntiBoxX1 And I5 <= .AntiBoxY2 And I5 >= .AntiBoxY1) Or (.AntiBoxX1 >= I4 And .AntiBoxX1 <= I6 And .AntiBoxY1 >= I5 And .AntiBoxY1 <= I7)
   f2 = (I6 >= .AntiBoxX1 And I6 <= .AntiBoxX2 And I5 <= .AntiBoxY2 And I5 >= .AntiBoxY1) Or (.AntiBoxX2 >= I4 And .AntiBoxX2 <= I6 And .AntiBoxY1 >= I5 And .AntiBoxY1 <= I7)
   f3 = (I6 >= .AntiBoxX1 And I6 <= .AntiBoxX2 And I7 >= .AntiBoxY1 And I7 <= .AntiBoxY2) Or (.AntiBoxX2 >= I4 And .AntiBoxX2 <= I6 And .AntiBoxY2 >= I5 And .AntiBoxY2 <= I7)
   f4 = (I4 <= .AntiBoxX2 And I4 >= .AntiBoxX1 And I7 >= .AntiBoxY1 And I7 <= .AntiBoxY2) Or (.AntiBoxX1 >= I4 And .AntiBoxX1 <= I6 And .AntiBoxY2 >= I5 And .AntiBoxY2 <= I7)
   If f Or f2 Or f3 Or f4 Then '16x16,1022x1022
    I2 = .Users(I).Xs
    If I2 = .Users(I).X Or I2 \ 16 < 16 Or I2 \ 16 > 1022 Then
     If Rnd < 0.5 Then I2 = .AntiBoxX1 - .AntiPixels / 2 - 6 Else I2 = .AntiBoxX2 + .AntiPixels / 2 + 6
    End If
    I3 = .Users(I).Ys
    If I3 = .Users(I).Y Or I3 \ 16 < 16 Or I3 \ 16 > 1022 Then
     If Rnd < 0.5 Then I3 = .AntiBoxY1 - .AntiPixels / 2 - 6 Else I3 = .AntiBoxY2 + .AntiPixels / 2 + 6
    End If
    PrivateMessage BotIndex, I, "*warpto " & I2 \ 16 & " " & I3 \ 16, 0
    Exit Sub
   End If
   .Users(I).Xs = .Users(I).X
   .Users(I).Ys = .Users(I).Y
  End If
 End If
Case 46 'BallPositionData
 If .BallNotify > 0 Then
  I = Asc(Mid(DecryptedPacket, 11, 1))
  AddTerminal BotIndex, "PBALL: " + .Users(I).Name + "[" + CStr(I) + "] (" + CStr(GetInteger(Mid(DecryptedPacket, 3, 2))) + "," + CStr(GetInteger(Mid(DecryptedPacket, 5, 2))) + ")", 12
  If I = 255 Then Exit Sub
  .Users(I).X = GetInteger(Mid(DecryptedPacket, 3, 2))
  .Users(I).Y = GetInteger(Mid(DecryptedPacket, 5, 2))
  If I <> .BallPlayer Then
   .BallPlayer = I
   If .BallTeam <> .Users(I).Freq Or .BallNotify = 1 Then
    .BallTeam = .Users(I).Freq
    PublicMessage BotIndex, "*arena Ball Carrier: " + .Users(.BallPlayer).Name + "(" + CStr(.BallTeam) + ") @ " + GetPlayerCoords(BotIndex, CInt(.BallPlayer)), 0
   End If
  End If
 End If
Case 29 'SetFreqAndShip
 I = Asc(Mid(DecryptedPacket, 3, 1))
 .Users(I).Ship = Asc(Mid(DecryptedPacket, 2, 1))
 .Users(I).Freq = GetInteger(Mid(DecryptedPacket, 5, 2))
 HandleShipChanges BotIndex, I
Case 32 'GotPrize
Case 33 'DoorFlip
Case 34 'FlagStatus
Case 13 'SetFreq
 I = Asc(Mid(DecryptedPacket, 2, 1))
 .Users(I).Freq = GetInteger(Mid(DecryptedPacket, 4, 2))
 HandleShipChanges BotIndex, I
Case 14 'MakeTurret only happens if a player attaches, not a bot by -attach on
Case 14 'Make Turret
'PlayerID = GetInteger(Mid(Data, 2, 2))
'If PlayerID <> -1 Then
'AddMessage Plist(PlayerID).UserName & " attached to " & Plist(GetInteger(Mid(Data, 4, 2))).UserName, Red
'Else
'AddMessage Plist(PlayerID).UserName & " detached", Red
'End If
Case 26 'ScoreReset
 If .Type <> 7 Then 'freeelim doesn't use subspace's scores data
  I = GetInteger(Mid(DecryptedPacket, 2, 2))
  If I = -1 Then 'all players got a scorereset
   For I2 = 0 To .LastUser
    .Users(I2).Points = 0
    .Users(I2).Wins = 0
    .Users(I2).Losses = 0
   Next
  Else 'only 1
   I = Asc(Mid(DecryptedPacket, 2, 1))
   .Users(I).Points = 0
   .Users(I).Wins = 0
   .Users(I).Losses = 0
  End If
 End If
End Select
End With
Exit Sub

FlyPaper:
AddTerminal BotIndex, "Error detected in HandleGamePacket(" + CStr(Asc(Left(DecryptedPacket, 1))) + "): " + Err.Description, 12
End Sub

Sub SendLogin(BotIndex As Byte, Name As String, Password As String, MacID As Long, TimeZoneBias As Integer, PermissionID As Integer, NewUser As Byte)
'UDPSend BotIndex, Chr(9) + Chr(NewUser) + FillZero(Name, 32) + FillZero(Password, 32) + GetStringL(MacID) + Chr(3) + GetStringI(TimeZoneBias) + GetStringI(PermissionID) + GetStringI(&H86) + GetStringL(&H1BC) + GetStringL(&H22B) + GetStringL(MacID \ 3) + String(12, Chr(0)), True 'remarked by me
UDPSend BotIndex, Chr(9) + Chr(NewUser) + FillZero(Name, 32) + FillZero(Password, 32) + GetStringL(MacID) + Chr(3) + GetStringI(TimeZoneBias) + GetStringI(PermissionID) + GetStringI(&H86) + GetStringL(&H1BC) + GetStringL(&H22B) + GetStringL(MacID) + String(12, Chr(0)), True
AddTerminal BotIndex, "Sending password packet: " + Name, 14
End Sub

Sub SendSync(BotIndex As Byte)
'Bots(BotIndex).SyncLocal = GetTickCount \ 10
Bots(BotIndex).SyncLocal = GetTickCount 'changing to just gettickcount. i think it's what supposed to be just like macid was
UDPSend BotIndex, Chr(0) + Chr(5) + GetStringL(Bots(BotIndex).SyncLocal) + GetStringL(Bots(BotIndex).TotalSent + 1) + GetStringL(Bots(BotIndex).TotalReceived), False 'i'm not sure about the .TotalSent + 1 part. + 1?  so i'll leave it how catid made it
Bots(BotIndex).GotSync = 0
End Sub

Function GetServerTime(BotIndex As Byte) As Long
'GetServerTime = GetTickCount \ 10 + Bots(BotIndex).SyncDiff + Bots(BotIndex).AvgPing
'GetServerTime = GetTickCount \ 10 + Bots(BotIndex).SyncDiff
GetServerTime = GetTickCount + Bots(BotIndex).SyncDiff
End Function

'Function Checksum(mStr As String) As Byte
'Dim I As Integer, b As Byte
'For I = 1 To Len(mStr)
' b = b Xor Asc(Mid(mStr, I, 1))
'Next
'Checksum = b
'End Function

'Sub InsertByte(mStr As String, Offset As Byte, NewByte As Byte)
'mStr = Left(mStr, Offset - 1) + Chr(NewByte) + Mid(mStr, Offset + 1)
'End Sub

Sub SendPosition(BotIndex As Byte, X As Integer, rX As Integer, Y As Integer, rY As Integer, D As Byte, Bounty As Integer, Weapon As Integer, CurrentEnergy As Integer, Blink As Byte)
Dim I As Integer, S As String, b As Byte
S = Chr(3) + Chr(D) + GetStringL(GetServerTime(BotIndex)) + GetStringI(rY) + GetStringI(Y) + Chr(0) + Chr(Blink) + GetStringI(X) + GetStringI(rX) + GetStringI(Bounty) + GetStringI(CurrentEnergy) + GetStringI(CInt(Weapon))
'InsertByte S, 11, Checksum(S)
For I = 1 To Len(S)
 b = b Xor Asc(Mid(S, I, 1))
Next
UDPSend BotIndex, Left(S, 10) + Chr(b) + Mid(S, 12), False
End Sub

Sub EnterArena(BotIndex As Byte, Ship As Byte, Arena As String, X_Resolution As Integer, Y_Resolution As Integer)
'&HFFFF = Random public arena
'&HFFFD = Private arena
'Else   = Public arena number
If IsPublicArena(Arena) Then
 If Arena = "" Then
  UDPSend BotIndex, Chr(1) + Chr(Ship) + Chr(1) + Chr(0) + GetStringI(X_Resolution) + GetStringI(Y_Resolution) + GetStringI(&HFFFF) + String(16, Chr(0)), True
  AddTerminal BotIndex, "Entering random public arena", 14
 Else
  UDPSend BotIndex, Chr(1) + Chr(Ship) + Chr(1) + Chr(0) + GetStringI(X_Resolution) + GetStringI(Y_Resolution) + GetStringI(Val(Arena)) + String(16, Chr(0)), True
  AddTerminal BotIndex, "Entering public arena # " + Arena, 14
 End If
Else
 UDPSend BotIndex, Chr(1) + Chr(Ship) + Chr(1) + Chr(0) + GetStringI(X_Resolution) + GetStringI(Y_Resolution) + GetStringI(&HFFFD) + FillZero(Arena, 16), True
 AddTerminal BotIndex, "Entering arena '" + Arena + "'", 14
End If
Bots(BotIndex).Arena = Arena 'temporary (need for speed), not saved in the INI
End Sub

Sub LeaveServer(BotIndex As Byte)
UDPSend BotIndex, Chr(0) + Chr(7), False
AddTerminal BotIndex, "Leaving server", 12
LogoffAllUsers BotIndex
End Sub

Sub LeaveArena(BotIndex As Byte)
Bots(BotIndex).SpawnConnected = 0
UDPSend BotIndex, Chr(2), True
LogoffAllUsers BotIndex
End Sub

Sub SendExtraInfo(BotIndex As Byte)
UDPSend BotIndex, Chr(0) + Chr(8) + Chr(&H17) + FillZero(App.Title, 32) + FillZero("Original creator: Catid@pacbell.net. Follower: DuckDuck@yahoo.com", 32) + String(27, 0), True
UDPSend BotIndex, Chr(0) + Chr(9) + String(92, 0), True
End Sub

Sub PrivateMessage(BotIndex As Byte, UserID As Integer, Message As String, SoundCode As Byte)
If Left(Message, 1) = "*" Then
 UDPSend BotIndex, Chr(6) + Chr(5) + Chr(SoundCode) + GetStringI(UserID) + Message + Chr(0), True
Else
 UDPSend BotIndex, Chr(6) + Chr(7) + Chr(SoundCode) + GetStringI(0) + ":" + Bots(BotIndex).Users(UserID).Name + ": " + Message + Chr(0), True
' AddQueue BotIndex, Chr(6) + Chr(7) + Chr(SoundCode) + GetStringI(0) + ":" + Bots(BotIndex).Users(UserID).Name + ": " + Message + Chr(0)
End If
End Sub

Sub PublicMessage(BotIndex As Byte, Message As String, SoundCode As Byte)
'If Left(Message, 1) = "*" Or Left(Message, 1) = "?" Then
' UDPSend BotIndex, Chr(6) + Chr(2) + Chr(SoundCode) + GetStringI(0) + Message + Chr(0), True
'Else
' AddQueue BotIndex, Chr(6) + Chr(2) + Chr(SoundCode) + GetStringI(0) + Message + Chr(0)
'End If
UDPSend BotIndex, Chr(6) + Chr(2) + Chr(SoundCode) + GetStringI(0) + Message + Chr(0), True
End Sub

Sub TeamM(BotIndex As Byte, Message As String, SoundCode As Byte)
'AddQueue BotIndex, Chr(6) + Chr(3) + Chr(SoundCode) + GetStringI(0) + Message + Chr(0)
UDPSend BotIndex, Chr(6) + Chr(3) + Chr(SoundCode) + GetStringI(0) + Message + Chr(0), True
End Sub

'PlayerAndMessage format = ":" + Player + ":" + Message
Sub RemoteM(BotIndex As Byte, PlayerAndMessage As String, SoundCode As Byte)
'AddQueue BotIndex, Chr(6) + Chr(7) + Chr(SoundCode) + GetStringI(0) + PlayerAndMessage + Chr(0)
UDPSend BotIndex, Chr(6) + Chr(7) + Chr(SoundCode) + GetStringI(0) + PlayerAndMessage + Chr(0), True
End Sub

Sub ChannelM(BotIndex As Byte, Message As String, SoundCode As Byte)
'AddQueue BotIndex, Chr(6) + Chr(9) + Chr(SoundCode) + GetStringI(0) + Message + Chr(0)
UDPSend BotIndex, Chr(6) + Chr(9) + Chr(SoundCode) + GetStringI(0) + Message + Chr(0), True
End Sub

'can't get to work (no need; can use "*setship")
'Sub ChangeShip(BotIndex as byte, ShipNo As Integer, FreqNo As Integer)
'UDPSend BotIndex, Chr(29) + GetStringI(ShipNo) + GetStringI(FreqNo), True
'End Sub

'Sub TrapPacket(BotIndex As Byte)
'UDPSend BotIndex, Chr(0) + Chr(14) + Chr(6) + Chr(5) + Chr(0) + GetStringI(Bots(BotIndex).UserID) + String(32, "-"), False
'End Sub

'Other commands
'Sub SendSecurityCheck(BotIndex as byte)
'UDPSend BotIndex, Chr(26) + GetStringL(0) + Chr(11) + Chr(94) + Chr(210) + Chr(113) + Chr(&H29) + Chr(&HF3) + Chr(&H4A) + Chr(&HCE) + Chr(&HE8) + Chr(&HCA) + Chr(&H62) + Chr(&HEF) + String(14, 0) + Chr(1) + Chr(0) + Chr(1) + Chr(0) + Chr(1) + Chr(0) + Chr(3) + Chr(0) + Chr(0), True
'UDPSend BotIndex, Chr(26) + String(39, 0), True
'1A 00 00 00 00 0B 5E D2 71 29 F3 4A CE E8 CA 62 EF 00 00 00 00 00 00 00 00 00 00 00 00 00 00 01 00 01 00 01 00 03 00 00
'End Sub

'Sub GetBall(BotIndex As Byte, BallNumber As Byte)
'UDPSend BotIndex, Chr(32) + Chr(BallNumber) + GetStringL(GetServerTime(BotIndex)), True
'End Sub

'Sub FireBall(BotIndex As Byte, BallNumber As Byte, x As Integer, y As Integer)
'UDPSend BotIndex, Chr(31) + Chr(BallNumber) + GetStringI(x) + GetStringI(y) + String(6, 0) + GetStringL(GetServerTime(BotIndex)), True
'End Sub

'Sub GetFlag(BotIndex As Byte, FlagNumber As Byte)
'UDPSend BotIndex, Chr(34) + Chr(FlagNumber) + GetStringL(GetServerTime(BotIndex)), True
'End Sub

'gotta find out what this does
'Sub RequestLocation(BotIndex As Byte, UserID as integer)
'UDPSend BotIndex, Chr(&H8) + GetStringI(UserID), True
'End Sub

'Sub AttachTo(BotIndex As Byte, UserID as integer)
'RequestLocation BotIndex, UserID
'UDPSend BotIndex, Chr(16) + GetStringI(UserID), True
'Bots(BotIndex).AttachedTo = UserID
'End Sub

'Sub LoadMap(LongFileName As String, rError As String)
'I = FreeFile
'on error Resume Next
'Open LongFileName For Binary Access Read As I
' If Err Then rError = "Map " + LongFileName + " could not be found": Exit Sub
' MapFullName = LongFileName
'Close I
'End Sub
